import $ from 'jquery'
import container from 'container'

export default function(elem, options) {

	var center = options.center;
	var north  = options.north;
	var south  = options.south;

	return {
		layout: function border(size) {

			if(!size){
				size = {height: elem.height()};
			}

			function h(elems){
				var dh = 0;

				elems && elems.each(function() {
					if($(this).is(':visible')) dh += parseFloat($(this).outerHeight(true));
				});

				return dh;
			}

			var nh = h(north);
			var sh = h(south);

			var s = {height: size.height - nh - sh, width: size.width};
			container.adjust(center, s);
			s.height -= parseFloat(center.css('borderTopWidth')) + parseFloat(center.css('borderBottomWidth'));

			var margin_collapse = check_margin_collapse();
			if(margin_collapse) console.log('border.layout: warning: possible margin-collapse error.');

			var center_height = s.height + margin_collapse;

			center
				.css({height: center_height})
				.attr('sizor', 'border')
				.trigger('resize', {height: center_height})
				.content()
				.triggerHandler('layout', s);

			if(north) {
				s = {width: size.width, height: nh};
				container.adjust(north, s);
				if(!north.autoHeight){
					north.css({height: s.height})
				}
				north.resize().content().triggerHandler('layout', s);
			}

			if(south) {
				s = {width: size.width, height: sh};
				container.adjust(south, s);
				if(!south.autoHeight){
					south.css({height: s.height});
				}
				south.resize().content().triggerHandler('layout', s);
			}

			function check_margin_collapse(){
				var a = parseFloat(north.css('marginBottom'));
				var b = parseFloat(center.css('marginTop'));
				var margin_collapse_1 = (a && b) ? Math.min(a, b) : 0;

				var c = parseFloat(center.css('marginBottom'));
				var d = parseFloat(south.css('marginTop'));
				var margin_collapse_2 = (c && d) ? Math.min(c, d) : 0;

				return margin_collapse_1 + margin_collapse_2;
			}
		}
	}
}

