import $ from 'jquery'
import container from 'container'

export default function(elem, options) {
	/*
	 *  The Vertical layout engine sets the height on a single element such that the element fills all the available vertical space.
	 *
	 *  @expandable       : the element to be managed
	 *  @detached (bool)  : size is taken from the elements parent rather than from the container chain (currently vertical layout only)
	 */

	var expandable = options.expandable;

	return {
		layout : function vertical(size) {
			var height = (!options.detached && size.height) || elem.parent().height();

			elem.children(':visible').not(expandable).each(function(){
				var child = $(this);
				if(child.css('float') !== 'left' && !this.container_exclude){
					height -= child.outerHeight(true);
				}
			});

			var s = $.extend(size, {height: height - parseFloat(elem.css('padding-top')) - parseFloat(elem.css('padding-bottom'))}); // WARNING will be wrong if border-box sizing is in use.
			expandable.css('height', parseInt(container.adjust(expandable, s).height, 10) - 1).resize().content().triggerHandler('layout', s);
		}
	}
}

