import $ from 'jquery'
import Dialogue from 'dialogue'
import User from 'user_info'
import h from 'virtual-dom/h'
import virtualise from 'vdom-virtualize'
import RenderTree from 'render-tree'

User.info.then(function(user) {
	$('#application, .inform-dialogue').hide()
	var el = $('body').div()
	var width = 480

	var vdom = new RenderTree({
		main: {
			render: function(){
				var body = h('.modal-body', [
					h('p', 'The charts dashboard is a place to organise your regularly used charts and diagrams.'),
					h('p', ['For more information, please see the ', h('a', {href: 'https://software.ecmwf.int/wiki/display/FCST/Chart+dashboard'}, 'documentation')])
				])
				return dialogue.render(body)
			}
		},
		root: el[0],
		tree: virtualise(self.dom_tree_root = el[0])
	})

	// TODO change layout method so that footer is always at bottom of dialogue
	vdom.on.render.once(function(){
		el.find('.modal-body').css({height: 200 - el.find('.modal-header').outerHeight(true) - el.find('.modal-footer').outerHeight(true)})
	})

	var dialogue = new Dialogue({
		id: 'login-warning',
		renderer: vdom,
		title: 'You are not logged in',
		size: {width: width, height: 200},
		position: {top: 100, left: $(window).width() / 2 - width / 2},
		footer: function() {
			if(!user.user_name)
				return [h('input.ui-button.ui-button-text.primary', {
					type: 'submit',
					value: 'Login',
					style: {float: 'right'},
					onclick: function() {
						location.href = '//' + window.ECMWF.options.backend_host + '/auth/login/?back=' + encodeURIComponent(location.href)
					}
				})]
		}
	})

	vdom.render()
})
