import Settings from 'settings'
import Product from 'chart/product'
import Chart from './chart'
import 'time-navigator'
var bus = require('bus')()
var $ = require('jquery')
require('tooltip/tipsy')

$.when(Settings.data).then(function(){
	var product;
	var chart;

	load_chart(function(_chart){
		chart = _chart;

		(chart && chart.create()) || ECMWF.alert({
			title: 'Chart not found',
			content: (
				ECMWF.request.widget
				? 'Cannot find widget "<b>' + $('<span>').text(ECMWF.request.widget).text() + '</b>"'
				: 'Chart not found: ' + $('#chart').chart('option', 'product')
			)
		});

		product = _chart.product
	});

	function load_chart(done){
		var qparams = ECMWF.query()

		if(qparams && qparams.widget){
			Ajaxqueue({
				url: '/backend/get-widget/',
				json: {name: qparams.widget},
				success: function (result) {
					done(new dashboardChartDelegate(result));
				},
				error: function (result) {
				}
			});
		/*
		} else if (ECMWF.request.product) {
			done(new presetChartDelegate());
		*/
		} else {
			done(new chartDelegate());
		}
	}

	function chartDelegate() {

		this.save = function(msg) {
			Settings.set('last-product', msg.product.get_save_state());
		}

		this.create = function() {
			this.product = new Product().init({product: Settings.get('last-product', 'wind')})

			return new Chart({
				product: this.product
			});
		}
	}

	function dashboardChartDelegate(widget) {

		ECMWF.request.widget = widget;

		this._title = widget.title;
		console.log('dashboardChartDelegate: widget.data:');
		console.log(widget.data);

		this.options = {
			product: widget.data.product,
			projection: widget.data.projection,
			title: $('#chart-title'),
			plugins: [resize]
		};

		this.save = function (msg) {
			if (Settings.get('auto-save-widgets', false)) {
				widget.data.product = msg.product.save();
				Ajaxqueue({
					priority: 'very-high',
					url: ECMWF.options.ajax.backend.save_widget,
					json: widget,
					logErrors: 'Save product',
					success: function (result) {
						console.log('done. ', result);
					}
				});
			}
		}

		this.create = function () {
			console.log('dashboardChartDelegate.create: product=', this.options.product);
			var c = $('#chart').chart(this.options);
			$('#gadget').triggerHandler('layout');
			return c;
		}
	}

	(function() {
		$('<div id="time-navigator">').insertAfter('#map').timeNavigator()

		product.availability(null, function() {
			var time = product._availability[0].first(product._availability)
			product.availability(time, function(availability) {
				bus.send('chart-product-availability', availability);
				$('#time-navigator').find('.containr').triggerHandler('layout', {width: $('body').width()});

				product.get_chart({
					json: {
						product: product.as_json({width: 100, height: 100}, availability.current),
						animate: null
					},
					success: function() {
						bus.send('chart-content-update', {
							product: product,
							time: availability.current
						})
					}
				})
			})
		})
	})()

	/*
	 *  In order to speed up the initialisation of the chart, both
	 *  the loading and execution of secondary items is delayed
	 */
	require(['./stage2'])
})
