import h from 'virtual-dom/h'
import './toolbar.css'
import 'menu-pane'
import LayerList from 'layer-list/2'
import Dialogue from 'dialogue'
import $ from 'jquery'

var layers_open = false

function Toolbar(options){
	var o = this.options = $.extend({
	}, options);
}

Toolbar.prototype = {

	render: function(body) {
		var self = this;
		return h('.ec-toolbar2', [
			h('div', [
				h('.layers', {
					onclick: function(){
						layers_open = true
						self.options.renderer.render()
					}
				})
			]),
			this.panels()
		]);
	},

	panels: function() {
		if(!layers_open) return []

		if(!this.dialogue){
			this.dialogue = new Dialogue({
				renderer: this.options.renderer,
				id: 'layers-panel',
				position: {right: 0}
			})

			this.layer_list = new LayerList({
				renderer: this.options.renderer
			})
		}

		return this.dialogue.render(this.layer_list.render())
	}
}

export default Toolbar;
