define(['jquery', 'bus', 'ajax_queue', 'notify'], function($, Bus, Ajaxqueue, notify) {

$(function() {
	ECMWF.options || (ECMWF.options = {});
	var notifications_timeout = ECMWF.options.settings.notifications_timeout || 30000;
	var notifications_initial_timeout = ECMWF.options.settings.notifications_initial_timeout || notifications_timeout;
	var default_timeout = notifications_timeout;
	var last = 0;
	var active = [];

	function get_notifications() {

		setTimeout(get_notifications, notifications_timeout);

		if(notifications_timeout < default_timeout) {
			notifications_timeout += 100;
		}

		Ajaxqueue({
			url: '/backend/get-notifications/',
			name: 'get_notifications',
			priority: 'very-low',
			json: {
				last    : last,
				active  : active,
				application: ECMWF.application
			},
			logErrors: 'Notification',
			success: function (data) {
				last = data.last;

				$.each(data.remove || [], function (_, id) {
					notify('close', id);
				});

				$.each(data.messages || [], function (_, msg) {

					msg.delivered = function (result) {
						Ajaxqueue({
							url: '/backend/notification-delivered/',
							priority: 'very-high',
							json: {
								id: msg.id,
								result: result
							}
						});
						active = $.grep(active, function (a) {
							return a !== msg.id;
						});
					};

					if(msg.action) {
						// TODO: Move this if in notify()
						msg.param = msg.param || {};
						Bus().send(msg.action, msg.param);
						notifications_timeout = 1000;
					} else {
						active.push(msg.id);
						notify(msg);
					}

					Ajaxqueue({
						url: '/backend/got-notification/',
						priority: 'very-low',
						json: {id: msg.id}
					});

					if(msg.action) {
						msg.delivered(msg.param);
					}
				})
			},
			error: function () {}
		})
	}

	($.getUserPreference && $.getUserPreference('notifications_disable')) || setTimeout(get_notifications, notifications_initial_timeout);
})

});
