/*
 *  Dialogue box containing user editable preferences.
 *
 *  Used in Eccharts and Dashboard
 */
define(['config', 'jquery', 'settings', 'chart/utils', 'bus', 'jquery-ui/widget'], function(ECMWF, $, Settings, Utils, Bus) {

$.widget('ui.preferences', {

	options: {
		bus: Bus()
	},

	_init: function() {
		var o = this.options;

		var items = [];
		Settings.each_pref(function(item){
			if(item.editable !== false) items.push(item);
		});

		ECMWF.dialogue({
			width: 480,
			title: 'Preferences',
			items: items,
			ok: function(form) {
				o.bus.send('preferences-changed', form);
			}
		}).parent()
			.attr('id', 'preferences')
	}
});

});

