/*
 *
 */
define(['jquery', 'virtual-dom/h'], function($, h) {

var Button = function(options){
	this.options = $.extend({
		icon: '',
		text: '',
		show_text: false,
		icon_position: null, // right by default, 'left' also supported
		className: '',
		on_click: function(){}
	}, options);

	this.disabled = false;
}

Button.prototype = {

	render: function() {
		var self = this, o = self.options;

		return h('.ui-button.ui-widget.ui-state-default' + (o.show_text ? '.ui-button-text-icon-secondary' : '.ui-button-icon-only') + (o.className ? '.' + o.className : '') + (o.icon_position ? '.left' : '' + (this.disabled ? ' .disabled' : '')), {
				title: o.text,
				onclick: function(e){
					self.disabled || o.on_click(e);
					e.stopPropagation()
				}
			}, [
			h('span.ui-icon' + (o.show_text ? '.ui-button-icon-secondary' : '.ui-button-icon-primary') + '.' + this.options.icon),
			h('span.ui-button-text', {}, [o.text])
		])
	},

	disable: function(bool) {
		this.disabled = bool !== false
		this.options.renderer.render()
	}
}

return Button;

});
